CREATE TABLE IF NOT EXISTS bandwidth_file(
header                              TEXT                        NOT NULL,
published                           TIMESTAMP WITHOUT TIME ZONE NOT NULL,
destination_countries               TEXT                        NOT NULL,
earliest_bandwidth                  TIMESTAMP WITHOUT TIME ZONE NOT NULL,
file_created                        TIMESTAMP WITHOUT TIME ZONE NOT NULL,
generator_started                   TIMESTAMP WITHOUT TIME ZONE NOT NULL,
latest_bandwidth                    TIMESTAMP WITHOUT TIME ZONE NOT NULL,
minimum_number_eligible_relays      INTEGER,
minimum_percent_eligible_relays     INTEGER,
number_consensus_relays             INTEGER,
number_eligible_relays              INTEGER,
percent_eligible_relays             INTEGER,
recent_consensus_count              INTEGER,
recent_measurement_attempt_count    INTEGER,
recent_measurement_failure_count    INTEGER,
recent_measurements_excluded_error_count   INTEGER,
recent_measurements_excluded_few_count     INTEGER,
recent_measurements_excluded_near_count    INTEGER,
recent_measurements_excluded_old_count     INTEGER,
recent_priority_list_count                 INTEGER,
recent_priority_relay_count                INTEGER,
scanner_country                     TEXT,
software                            TEXT,
software_version                    TEXT,
tor_version                         TEXT,
time_to_report_half_network         INTEGER,
spec_version                        TEXT,
digest                              TEXT                         NOT NULL,
PRIMARY KEY(digest)
);

CREATE TABLE IF NOT EXISTS bandwidth_record(
  digest                                          TEXT,
  bw                                              BIGINT,
  bw_mean                                         BIGINT,
  bw_median                                       BIGINT,
  consensus_bandwidth                             BIGINT,
  consensus_bandwidth_is_unmeasured               BOOLEAN,
  desc_bw_avg                                     BIGINT,
  desc_bw_bur                                     BIGINT,
  desc_bw_obs_last                                BIGINT,
  desc_bw_obs_mean                                BIGINT,
  error_circ                                      INTEGER,
  error_destination                               INTEGER,
  error_misc                                      INTEGER,
  error_second_relay                              INTEGER,
  error_stream                                    INTEGER,
  master_key_ed25519                              TEXT,
  nick                                            TEXT,
  node_id                                         TEXT,
  rtt                                             INTEGER,
  relay_in_recent_consensus_count                 INTEGER,
  relay_recent_measurement_attempt_count          INTEGER,
  relay_recent_measurements_excluded_error_count  INTEGER,
  relay_recent_measurement_failure_count          INTEGER,
  relay_recent_measurements_excluded_near_count   INTEGER,
  relay_recent_measurements_excluded_old_count    INTEGER,
  relay_recent_measurements_excluded_few_count    INTEGER,
  relay_recent_priority_list_count                INTEGER,
  under_min_report                                BOOLEAN,
  unmeasured                                      BOOLEAN,
  vote                                            BOOLEAN,
  xoff_recv                                       INTEGER,
  xoff_sent                                       INTEGER,
  success                                         INTEGER,
  time                                            TIMESTAMP WITHOUT TIME ZONE NOT NULL,
  bandwidth_file                                  TEXT references bandwidth_file(digest),
  PRIMARY KEY(digest, time));
