CREATE TABLE IF NOT EXISTS onionperf_analysis(
  onionperf_node                    TEXT                          NOT NULL,
  published                         TIMESTAMP WITHOUT TIME ZONE   NOT NULL,
  measurement_ip                    TEXT                          NOT NULL,
  type                              TEXT                          NOT NULL,
  version                           TEXT                          NOT NULL,
  filters                           TEXT                          NOT NULL,
  digest                            TEXT                          NOT NULL,
  PRIMARY KEY(digest)
);

CREATE TABLE IF NOT EXISTS onionperf_tgen_stream(
  measurement_ip                    TEXT                          NOT NULL,
  onionperf_node                    TEXT                          NOT NULL,
  stream_id                         TEXT                          NOT NULL,
  onionperf_analysis_digest         TEXT                          NOT NULL,
  byte_info_payload_bytes_recv      DOUBLE PRECISION,
  byte_info_payload_bytes_send      DOUBLE PRECISION,
  byte_info_payload_progress_recv   DOUBLE PRECISION,
  byte_info_payload_progress_send   DOUBLE PRECISION,
  byte_info_total_bytes_recv        DOUBLE PRECISION,
  byte_info_total_bytes_send        DOUBLE PRECISION,
  elapsed_seconds_payload_bytes_recv    DOUBLE PRECISION[],
  elapsed_seconds_payload_bytes_send    DOUBLE PRECISION[],
  elapsed_seconds_payload_progress_recv DOUBLE PRECISION[],
  elapsed_seconds_payload_progress_sent DOUBLE PRECISION[],
  is_complete                       BOOLEAN,
  is_error                          BOOLEAN,
  is_success                        BOOLEAN,
  stream_info_error                 TEXT,
  stream_info_id                    BIGINT,
  stream_info_name                  TEXT,
  stream_info_peername              TEXT,
  stream_info_recvsize              BIGINT,
  stream_info_rexvstate             TEXT,
  stream_info_sendsize              BIGINT,
  stream_info_idsendstate           TEXT,
  stream_info_vertexid              TEXT,
  time_info_created_ts              TIMESTAMP WITHOUT TIME ZONE,
  time_info_now_ts                  TIMESTAMP WITHOUT TIME ZONE,
  time_info_usecs_to_checksum_recv  BIGINT,
  time_info_usecs_to_checksum_send  BIGINT,
  time_info_usecs_to_command        BIGINT,
  time_info_usecs_to_first_byte_recv    BIGINT,
  time_info_usecs_to_first_byte_send    BIGINT,
  time_info_usecs_to_last_byte_recv     BIGINT,
  time_info_usecs_to_last_byte_send     BIGINT,
  time_info_usecs_to_proxy_choice       BIGINT,
  time_info_usecs_to_proxy_init         BIGINT,
  time_info_usecs_to_proxy_request      BIGINT,
  time_info_usecs_to_proxy_response     BIGINT,
  time_info_usecs_to_response           BIGINT,
  time_info_usecs_to_socket_connect     BIGINT,
  time_info_usecs_to_socket_create      BIGINT,
  transport_info_error                  TEXT,
  transport_info_fd                     BIGINT,
  transport_info_local                  TEXT,
  transport_info_proxy                  TEXT,
  transport_info_remote                 TEXT,
  transport_info_state                  TEXT,
  unix_ts_end                           TIMESTAMP WITHOUT TIME ZONE,
  unix_ts_start                         TIMESTAMP WITHOUT TIME ZONE,
  onionperf_analysis                TEXT references onionperf_analysis(digest),
  PRIMARY KEY(stream_id),
);
